
local  x, y, z, scale = 0, 0, 1, 1

function love.load()

    maid64 = require("libraries.maid64")
    love.window.setMode(0,0,
    {
        fullscreen = true,
        fullscreentype = "exclusive",
    })
    maid64.setup(640,480)


    LightWorld = require("libraries.lightworld")
    LW = LightWorld({

        ambient = {20,20,20},
        refractionStrength = 0.0,
        glowBlur = 0.5,
        reflectionVisibility = 0.0,

	})
    LW:refreshScreenSize(640,480)

    lightMouse = LW:newLight(0, 0, 255, 255, 255, 300)
    lightMouse:setSmooth(1)
    lightMouse:setGlowStrength(0.3)

    gamera = require("libraries.gamera")

    cam = gamera.new(0, 0, 2000, 2000)
    cam:setWindow(0,0,640,480)

    camPosition = {}
    camPosition.x = x
    camPosition.y = y

end

function love.mousepressed(dx, dy, button, istouch)

   if button == 1 then
        local newlight = LW:newLight((love.mouse.getX() - x)/scale, (love.mouse.getY() - y)/scale, 255, 255, 255, 400)
        newlight:setSmooth(1)
        newlight:setGlowStrength(0.3)
   end

end

function love.update(dt)


    lightMouse:setPosition((love.mouse.getX() - x)/scale, (love.mouse.getY() - y)/scale, z)
    camPosition.x = -x
    camPosition.y = -y

	if love.keyboard.isDown("down") then
		y = y - dt * 500
	elseif love.keyboard.isDown("up") then
		y = y + dt * 500
	end

	if love.keyboard.isDown("right") then
		x = x - dt * 500
	elseif love.keyboard.isDown("left") then
		x = x + dt * 500
	end
	if love.keyboard.isDown("q") then
        love.event.quit()
    end


    cam:setScale(scale)
    cam:setPosition(x, y)

    LW:setTranslation(x, y, scale)
    LW:update(dt)

end

function love.draw()
    maid64.start()
    cam:draw(function(l,t,w,h)
        LW:draw(function()
            love.graphics.setColor(255,255,255)
            love.graphics.rectangle("fill", -x/scale, -y/scale, love.graphics.getWidth()/scale, love.graphics.getHeight()/scale)
        end)
    end)
    maid64.finish()
end

